import socket

server_address = '0.0.0.0'  # Listen on all
server_port = 9999  # Listen on Port 9999
controller_name = "Arduino"  # Name or ID of your Controller

sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
controller_address = ""
controller_reg = False
client_adr = ""
client_reg = False
RECV_BUFFER = ""  # Buffer for received data
server = (server_address, server_port)
sock.bind(server)  # Start Socket on Server and bind address
print("Listening on " + server_address + ":" + str(server_port))

while True:
    print("---")
    payload, client_address = sock.recvfrom(1024)
    print("OK     <-Received: " + str(payload) + " From: " + str(client_address))
    RECV_BUFFER = str(payload)  # Save received data into buffer
    data = RECV_BUFFER.split(";")  # Create array split by ; ( eg. ;Arduino;Parameter;... )
    datalen = len(data)  # Get length of elements in data array
    if datalen == 4:
        device = str(data[1])
        device_cmd = str(data[2])
        if device == controller_name:  # If your controller (eg. Arduino) has connected
            controller_reg = True
            controller_address = client_address
            print("OK     ->Send Response to Controller at " + str(controller_address))
            if client_reg and device_cmd != "Keep-Alive":
                sent = sock.sendto(bytes("MSG-DEV: " + device_cmd, 'utf-8'), client_adr)
                print("OK     ->Controller confirmed command")
        sent = sock.sendto(b"MSG-SRV: Received!", controller_address)  # Send "M:MSG Received! to connected Controller
    else:
        if controller_address != "" and controller_reg == True:
            if datalen == 1:
                if "CMD:" in str(data[0]):
                    print("OK     ->Send Command to Controller (" + data[0] + ")")
                    sent = sock.sendto(bytes(data[0], 'utf-8'), controller_address)
                    sent = sock.sendto(bytes("MSG-SRV: CMD forwarded to " + controller_name, 'utf-8'), client_address)
                    client_reg = True
                    client_adr = client_address
                else:
                    sent = sock.sendto(b"Warning: Message received, but not forwarded to client!", client_address)
                    client_reg = True
                    client_adr = client_address
            else:
                print("OK     <-Received unknown Control Command")
        else:
            print("Error: Controller is not connected")
            sent = sock.sendto(b"Error: Controller is not connected", client_address)
